Imports System
Imports System.Collections
Imports System.Drawing
Imports System.Windows.Forms
Imports GTA

Public Class SaveJenny
    Inherits Script
    Private Scripton As Boolean = False
    Private Jenny As Boolean = False
    Private r As Integer
    Private anims As New AnimationSet("amb@drunk")
    Private animflags As AnimationFlags = AnimationFlags.Unknown12 Or AnimationFlags.Unknown11 Or AnimationFlags.Unknown10 Or AnimationFlags.Unknown09 'Or AnimationFlags.Unknown08 Or AnimationFlags.Unknown07 Or AnimationFlags.Unknown06 Or AnimationFlags.Unknown05 Or AnimationFlags.Unknown04 Or AnimationFlags.Unknown03 Or AnimationFlags.Unknown02 Or AnimationFlags.Unknown01
    Private Group As Group = Player.Group
    Private screenFont As New GTA.Font(0.04F, FontScaling.ScreenUnits)
    Private screenBoxColor As Color = Color.FromArgb(0, 0, 0, 0)
    Private timer As New GTA.Timer
    Public Sub New()
        'Me.interval = 350
        Timer.start()
        World.UnlockAllIslands()
        Game.AllowEmergencyServices = False
        Player.NeverGetsTired = True
        player.character.Weapons.RemoveAll()
        player.character.Weapons.MolotovCocktails.Ammo += 8
        Group.SeparationRange = 10.0F
        screenFont.Color = Color.white ' health
    End Sub

    Private Function Ra(ByVal min As Integer, ByVal max As Integer) As Integer
        Dim random As New Random()
        Return random.Next(min, max)
    End Function
    Private Sub SaveJenny_Tick(ByVal sender As Object, ByVal e As EventArgs) Handles MyBase.Tick
        If timer.ElapsedTime > 350 Then
            If Scripton = True Then

                If Not Player.Character.isAlive Then
                    If player.character.isalive = False Then
                        Dim peds As ped() = world.getpeds(player.character.position, 300.0F)
                        For Each ped As ped In peds
                            If exists(ped) AndAlso ped IsNot Nothing AndAlso Not ped = player.character Then
                                ped.delete()
                            End If
                        Next

                        Dim vehicles As vehicle() = world.getallvehicles()
                        For Each vehicle As vehicle In vehicles
                            If exists(vehicle) AndAlso vehicle IsNot Nothing AndAlso vehicle.isrequiredformission = True Then
                                vehicle.delete()
                            End If
                        Next
                    End If
                    Scripton = False
                    Jenny = False
                    Dim rand As Integer = Ra(0, 6)
                    Native.Function.Call("FORCE_WEATHER_NOW", rand)
                    Native.Function.Call("SWITCH_AMBIENT_PLANES", 1)
                    Native.Function.Call("SET_MAX_WANTED_LEVEL", 6)
                    Native.Function.Call("ENABLE_POLICE_SCANNER")
                    Native.Function.Call("DONT_DISPATCH_COPS_FOR_PLAYER", Player, 0)
                    world.peddensity = 1.0
                    world.cardensity = 1.0

                Else
                    Jenny = True
                    Native.Function.Call("DRAW_LIGHT_WITH_RANGE", -277.515, -282.295, 14.6, 0, 0, 250, 2.0F, 95.0F)
                    With Player.Character
                        If player.character.weapons.DesertEagle.Ammo < 60 Then
                            .Weapons.DesertEagle.Ammo += 1
                        End If

                        If player.character.Weapons.MP5.ammo < 300 Then
                            .Weapons.MP5.Ammo += 1
                        End If

                        If player.character.Weapons.BarettaShotgun.Ammo < 80 Then
                            .Weapons.BarettaShotgun.Ammo += 1
                        End If
                        r = Ra(0, 4)
                        If r = 1 Then
                            .health += 1
                            .armor += 1
                        End If

                    End With

                    Dim peds As ped() = world.GetPeds(Player.Character.Position.Around(9.0F), 455.9F, 40)
                    For Each Zombie As ped In peds

                        If Not Exists(zombie) OrElse Zombie Is Nothing OrElse Zombie.isRequiredForMission OrElse Not Player.Character.isAlive OrElse Native.Function.Call(Of Boolean)("IS_PED_CLIMBING", Zombie) OrElse Zombie.isGettingIntoAVehicle OrElse Zombie.isRagdoll OrElse Not Zombie.isAlive OrElse Zombie = Player.Character Then
                            Continue For
                        End If

                        If Exists(zombie) AndAlso Zombie IsNot Nothing Then
                            If (Native.Function.Call(Of Boolean)("IS_PED_ATTACHED_TO_ANY_CAR", Zombie)) AndAlso (Not Player.Character.isSittingInVehicle()) Then
                                Native.Function.Call("DETACH_PED", Zombie)
                            End If

                            If Zombie.isSittingInVehicle() Then
                                Zombie.Task.LeaveVehicleImmediately(Zombie.CurrentVehicle)
                                Wait(0)
                            End If
                            If Exists(zombie) AndAlso Zombie IsNot Nothing AndAlso Native.Function.Call(Of Boolean)("IS_CHAR_SITTING_IDLE", Zombie) Then
                                Zombie.Euphoria.BodyBalance.Start(100)
                                Wait(0)
                            End If
                            If Exists(zombie) AndAlso Zombie IsNot Nothing Then
                                Zombie.DuckWhenAimedAtByGroupMember = False
                                zombie.enemy = True
                                Zombie.Weapons.RemoveAll()
                                Zombie.Voice = "M_ZOMBIE"
                                Zombie.SetPathfinding(True, True, True)
                                Zombie.Task.GoTo(Player.Character.Position, True)
                                Native.Function.Call("SET_PED_DONT_DO_EVASIVE_DIVES", Zombie, 1)
                                Native.Function.Call("SET_CHAR_SUFFERS_CRITICAL_HITS", Zombie, 1)
                                Zombie.AlwaysDiesOnLowHealth = True
                                Zombie.maxhealth = 175
                                Native.Function.Call("SET_CHAR_MONEY", Zombie, 0)
                                If Exists(zombie) AndAlso Zombie IsNot Nothing AndAlso zombie.isingroup = False AndAlso zombie.isonfire = False Then
                                    zombie.isonfire = True
                                    zombie.MakeProofTo(False, True, False, False, False)
                                End If

                                r = Ra(0, 6)
                                If (r = 2) AndAlso Exists(zombie) AndAlso Zombie IsNot Nothing AndAlso Not Native.Function.Call(Of Boolean)("IS_CHAR_PLAYING_ANIM", Zombie, "amb@drunk", "bum_fight") AndAlso Not Native.Function.Call(Of Boolean)("IS_CHAR_GETTING_UP", Zombie) AndAlso Not Zombie.isSittingInVehicle() Then
                                    Zombie.Task.PlayAnimation(anims, "bum_fight", 10.0F, animflags)
                                End If

                                r = Ra(0, 3)
                                If (r = 1) AndAlso Exists(zombie) AndAlso Zombie IsNot Nothing AndAlso Not Native.Function.Call(Of Boolean)("IS_CHAR_PLAYING_ANIM", Zombie, "amb@drunk", "bum_fight") AndAlso Not Native.Function.Call(Of Boolean)("IS_CHAR_GETTING_UP", Zombie) AndAlso Not Zombie.isSittingInVehicle() Then
                                    Native.Function.Call("SAY_AMBIENT_SPEECH", Zombie, "MOAN", 1, 1, 2)
                                End If

                                If Exists(zombie) AndAlso Zombie IsNot Nothing AndAlso zombie.health < 175.0 AndAlso zombie.isrequiredformission = False Then
                                    zombie.health += 25
                                End If
                            End If
                            If Exists(zombie) AndAlso Zombie IsNot Nothing Then

                                r = Ra(3, 10)
                                If (r = 4) AndAlso Not Native.Function.Call(Of Boolean)("IS_CHAR_IN_AIR", Zombie) Then
                                    Zombie.ApplyForce(New Vector3(0.0F, -2.5F, 0.0F))
                                End If
                                r = Ra(3, 10)
                                If (r = 4) AndAlso Not Native.Function.Call(Of Boolean)("IS_CHAR_IN_AIR", Zombie) Then
                                    Zombie.ApplyForce(New Vector3(0.0F, 2.5F, 0.0F))
                                End If
                            End If

                            If Exists(zombie) AndAlso Zombie IsNot Nothing Then
                                Dim vx As Single = Zombie.Velocity.X, vy As Single = Zombie.Velocity.Y
                                vx = vx * vx
                                vy = vy * vy

                                r = Ra(0, 2)

                                If (r = 1) AndAlso Exists(zombie) AndAlso Zombie IsNot Nothing AndAlso Not Native.Function.Call(Of Boolean)("IS_CHAR_GETTING_UP", Zombie) AndAlso Not Native.Function.Call(Of Boolean)("IS_PED_CLIMBING", Zombie) AndAlso Not Zombie.isSittingInVehicle() AndAlso (vx < 0.1F) AndAlso (vy < 0.1F) Then
                                    If player.character.position.distanceto(zombie.position) >= 2.2 Then
                                        Native.Function.Call("TASK_CLIMB", Zombie, 3)
                                    End If
                                    Wait(0)
                                End If
                            End If
                        End If
                    Next

                    Dim zombz As ped() = world.getpeds(player.character.position, 25.0, 6)
                    For Each zomb As ped In zombz
                        If exists(zomb) AndAlso zomb IsNot Nothing AndAlso Not zomb = player.character AndAlso zomb.isingroup = False Then
                            r = Ra(0, 4)
                            If r = 0 Then
                                If exists(zomb) AndAlso zomb IsNot Nothing AndAlso zomb.isonscreen = True Then
                                    Native.Function.Call("SET_ANIM_GROUP_FOR_CHAR", zomb, "move_injured_lower")
                                End If
                            End If
                            If r = 1 Then
                                If exists(zomb) AndAlso zomb IsNot Nothing AndAlso zomb.isonscreen = False Then
                                    Native.Function.Call("SET_ANIM_GROUP_FOR_CHAR", zomb, "move_injured_upper")
                                End If
                            End If
                            If r = 2 Then
                                If exists(zomb) AndAlso zomb IsNot Nothing AndAlso zomb.isonscreen = False Then
                                    Native.Function.Call("Set_Char_Move_Anim_Speed_Multiplier", zomb, 1.2)
                                End If

                            End If
                            If r = 3 Then
                                If exists(zomb) AndAlso zomb IsNot Nothing Then
                                    Native.Function.Call("Set_Char_Move_Anim_Speed_Multiplier", zomb, 1.7)
                                End If
                            End If
                        End If

                        If exists(zomb) AndAlso zomb IsNot Nothing AndAlso Not zomb = player.character AndAlso zomb.isingroup = False Then
                            r = Ra(0, 90)
                            If r = 18 Then
                                If exists(zomb) AndAlso zomb IsNot Nothing AndAlso zomb.isonscreen = False AndAlso zomb.position.distanceto(player.character.position) > 20.0 Then
                                    Native.Function.Call("Set_Char_Move_Anim_Speed_Multiplier", zomb, 3.5)
                                End If
                            End If
                        End If

                        If exists(zomb) AndAlso zomb IsNot Nothing AndAlso Not zomb = player.character AndAlso zomb.isingroup = False AndAlso zomb.model = "F_Y_Prich_01" = True AndAlso zomb.isrequiredformission = True AndAlso zomb.position.distanceto(player.character.position) < 8.0F AndAlso zomb.isalive = True Then
                            group.addmember(zomb)
                            Native.Function.Call("PRINT_STRING_WITH_LITERAL_STRING_NOW", "STRING", "Get Jenny To The Church", 4000, 1)
                            world.peddensity = 3.0
                            world.cardensity = 2.5
                            Jenny = False
                        End If

                        If exists(zomb) AndAlso zomb IsNot Nothing AndAlso Not zomb = player.character AndAlso zomb.isingroup = False AndAlso zomb.model = "F_Y_Prich_01" = True AndAlso zomb.isrequiredformission = True AndAlso zomb.position.distanceto(player.character.position) < 8.0F AndAlso zomb.isalive = False Then
                            'group.addmember(zomb)
                            Jenny = False
                            Native.Function.Call("PRINT_STRING_WITH_LITERAL_STRING_NOW", "STRING", "You Failed To Save Her Soul", 4000, 1)
                        End If
                    Next

                    Dim q As Integer = Ra(0, 10)
                    If q = 4 Then
                        Dim c As Integer = Ra(0, 6)
                        If c = 0 Then
                            Dim a As Integer = Ra(-28, -24)
                            Dim b As Integer = Ra(-28, -24)
                            Dim vehicles As vehicle() = world.getvehicles(player.character.getoffsetposition(New vector3(a, b, 0.0F)), 15.0F)
                            For Each vehicle As vehicle In vehicles
                                If exists(vehicle) AndAlso vehicle IsNot Nothing AndAlso vehicle.isrequiredformission = False Then
                                    vehicle.explode()
                                End If
                            Next
                        End If
                        If c = 1 Then
                            Dim a As Integer = Ra(-28, -24)
                            Dim b As Integer = Ra(24, 28)
                            Dim vehicles As vehicle() = world.getvehicles(player.character.getoffsetposition(New vector3(a, b, 0.0F)), 15.0F)
                            For Each vehicle As vehicle In vehicles
                                If exists(vehicle) AndAlso vehicle IsNot Nothing AndAlso vehicle.isrequiredformission = False Then
                                    vehicle.explode()
                                End If
                            Next
                        End If
                        If c = 4 Then
                            Dim a As Integer = Ra(24, 28)
                            Dim b As Integer = Ra(-28, -24)
                            Dim vehicles As vehicle() = world.getvehicles(player.character.getoffsetposition(New vector3(a, b, 0.0F)), 15.0F)
                            For Each vehicle As vehicle In vehicles
                                If exists(vehicle) AndAlso vehicle IsNot Nothing AndAlso vehicle.isrequiredformission = False Then
                                    vehicle.explode()
                                End If
                            Next
                        End If
                        If c = 3 Then
                            Dim a As Integer = Ra(24, 28)
                            Dim b As Integer = Ra(24, 28)
                            Dim vehicles As vehicle() = world.getvehicles(player.character.getoffsetposition(New vector3(a, b, 0.0F)), 15.0F)
                            For Each vehicle As vehicle In vehicles
                                If exists(vehicle) AndAlso vehicle IsNot Nothing AndAlso vehicle.isrequiredformission = False Then
                                    vehicle.explode()
                                End If
                            Next
                        End If

                        If c = 2 Then
                            Dim b As Integer = Ra(24, 28)
                            Dim vehicles As vehicle() = world.getvehicles(player.character.getoffsetposition(New vector3(0.0, b, 0.0F)), 15.0F)
                            For Each vehicle As vehicle In vehicles
                                If exists(vehicle) AndAlso vehicle IsNot Nothing AndAlso vehicle.isrequiredformission = False Then
                                    vehicle.explode()
                                End If
                            Next
                        End If

                        If c = 5 Then
                            Dim b As Integer = Ra(-28, -24)
                            Dim vehicles As vehicle() = world.getvehicles(player.character.getoffsetposition(New vector3(0.0, b, 0.0F)), 15.0F)
                            For Each vehicle As vehicle In vehicles
                                If exists(vehicle) AndAlso vehicle IsNot Nothing AndAlso vehicle.isrequiredformission = False Then
                                    vehicle.explode()
                                End If
                            Next
                        End If

                    End If
                    Dim ec As Integer = Ra(0, 35)
                    If ec = 12 Then
                        Dim vehicle As vehicle = world.getclosestvehicle(player.character.position, 20.0F)
                        If exists(vehicle) AndAlso vehicle IsNot Nothing AndAlso vehicle.position.distanceto(player.character.position) >= 5.0 AndAlso vehicle.isrequiredformission = False Then
                            vehicle.explode()
                        End If
                    End If

                End If

            Else
                If Native.Function.Call(Of Boolean)("Is_Char_In_Area_2D", Player.Character, 458.33, 323.05, 460.68, 323.35) AndAlso player.character.isonfire = True Then
                    Native.Function.Call("SET_TIME_OF_DAY", 6, 11)
                    Native.Function.Call("FORCE_WEATHER_NOW", 7)
                    Scripton = True
                    Native.Function.Call("Do_Screen_Fade_Out", 650)
                    Wait(2000)
                    Native.Function.Call("Do_Screen_Fade_In", 1650)
                    Native.Function.Call("PRINT_STRING_WITH_LITERAL_STRING_NOW", "STRING", "Save Jenny's Soul From Hell!", 4000, 1)
                    Native.Function.Call("SWITCH_AMBIENT_PLANES", 0)
                    Native.Function.Call("DONT_DISPATCH_COPS_FOR_PLAYER", Player, 1)

                    world.peddensity = 2.0
                    world.cardensity = 2.0

                    Dim vehicle As vehicle = world.createvehicle("Comet", New vector3(2277.63, 839.81, 6.0))
                    If exists(vehicle) AndAlso vehicle IsNot Nothing Then
                        vehicle.heading = 64.57
                        vehicle.isrequiredformission = True
                        vehicle.MakeProofTo(False, True, True, False, False)
                    Else
                        vehicle = world.createvehicle("Comet", New vector3(2277.63, 839.81, 6.0))
                        If exists(vehicle) AndAlso vehicle IsNot Nothing Then
                            vehicle.heading = 64.57
                            vehicle.isrequiredformission = True
                            vehicle.MakeProofTo(False, True, True, False, False)
                        End If
                    End If

                    Dim ped As ped = world.createped("F_Y_Prich_01", New vector3(2285.08F, 905.5F, 5.85F))
                    If exists(ped) AndAlso ped IsNot Nothing Then
                        ped.heading = 336.49F
                        ped.becomemissioncharacter()
                        Ped.GiveFakeNetworkName("Jenny", color.white)
                        ped.health = 100
                        Ped.armor = 100
                        ped.isonfire = True
                        ped.MakeProofTo(False, True, True, False, False)
                        Native.Function.Call("SET_ANIM_GROUP_FOR_CHAR", ped, "move_injured_upper")
                    Else
                        ped = world.createped("F_Y_Prich_01", New vector3(2285.08F, 905.5F, 5.85F))
                        If exists(ped) AndAlso ped IsNot Nothing Then
                            ped.heading = 336.49F
                            ped.becomemissioncharacter()
                            Ped.GiveFakeNetworkName("Jenny", color.white)
                            ped.health = 100
                            Ped.armor = 100
                            ped.isonfire = True
                            ped.MakeProofTo(False, True, True, False, False)
                            Native.Function.Call("SET_ANIM_GROUP_FOR_CHAR", ped, "move_injured_upper")
                        Else
                            ped = world.createped("F_Y_Prich_01", New vector3(2285.08F, 905.5F, 5.85F))
                            If exists(ped) AndAlso ped IsNot Nothing Then
                                ped.heading = 336.49F
                                ped.becomemissioncharacter()
                                Ped.GiveFakeNetworkName("Jenny", color.white)
                                ped.health = 100
                                Ped.armor = 100
                                ped.isonfire = True
                                ped.MakeProofTo(False, True, True, False, False)
                                Native.Function.Call("SET_ANIM_GROUP_FOR_CHAR", ped, "move_injured_upper")
                            End If
                        End If
                    End If
                End If
            End If
        End If
        If Scripton = False Then
            Native.Function.Call("DRAW_LIGHT_WITH_RANGE", 459.51, 323.2, 8.57, 250, 0, 10, 20.0F, 95.0F)
        End If
        If Scripton = True Then
            Native.Function.Call("DONT_DISPATCH_COPS_FOR_PLAYER", Player, 1)
            Native.Function.Call("SET_MAX_WANTED_LEVEL", 0)
            Native.Function.Call("ALTER_WANTED_LEVEL", Player, 0)
            Native.Function.Call("APPLY_WANTED_LEVEL_CHANGE_NOW", Player.character)
        End If

        If Native.Function.Call(Of Boolean)("Is_Char_In_Area_2D", Player.Character, -277.61, -284.04, -277.42, -280.55) AndAlso Scripton = True AndAlso group.membercount = 1 AndAlso player.character.isonfire = False Then
            Native.Function.Call("Do_Screen_Fade_Out", 650)
            Dim peds As ped() = world.getpeds(player.character.position, 300.0F)
            For Each ped As ped In peds
                If exists(ped) AndAlso ped IsNot Nothing AndAlso Not ped = player.character AndAlso ped.isingroup = False Then
                    ped.delete()
                End If
            Next

            Dim vehicles As vehicle() = world.getallvehicles()
            For Each vehicle As vehicle In vehicles
                If exists(vehicle) AndAlso vehicle IsNot Nothing Then
                    vehicle.delete()
                End If
            Next

            Player.TeleportTo(New Vector3(-322.43F, -294.47, 13.51F))
            For Each member As ped In group
                member.die()
            Next
            Wait(1000)
            Native.Function.Call("Do_Screen_Fade_In", 1650)

            Dim rand As Integer = Ra(0, 6)
            Native.Function.Call("FORCE_WEATHER_NOW", rand)
            Native.Function.Call("PRINT_STRING_WITH_LITERAL_STRING_NOW", "STRING", "You Saved Jenny's Soul", 4000, 1)
            Native.Function.Call("SET_MAX_WANTED_LEVEL", 6)
            Native.Function.Call("ENABLE_POLICE_SCANNER")
            Native.Function.Call("DONT_DISPATCH_COPS_FOR_PLAYER", Player, 0)
            Native.Function.Call("SWITCH_AMBIENT_PLANES", 1)
            Native.Function.Call("SET_TIME_OF_DAY", 12, 15)
            Native.Function.Call("DONT_DISPATCH_COPS_FOR_PLAYER", Player, 0)
            world.peddensity = 1.0
            world.cardensity = 1.0
            Scripton = False
            Jenny = False
        End If
    End Sub
    Protected Sub FindingJenny_PerFrameDrawing(ByVal sender As Object, ByVal e As GraphicsEventArgs) Handles MyBase.PerFrameDrawing
        If Scripton = True Then
            If group.membercount < 1 AndAlso Jenny = True Then
                Dim x As Integer = player.character.position.x
                Dim y As Integer = player.character.position.y
                e.Graphics.Scaling = FontScaling.ScreenUnits
                Dim rect = New RectangleF(0.0F, 0.45F, 0.2F, 0.1F)
                e.Graphics.DrawRectangle(rect, screenBoxColor)
                e.Graphics.DrawText(x & y, rect, TextAlignment.Center Or TextAlignment.VerticalCenter, screenFont)
            End If
        End If
    End Sub
End Class
